/*
 * OpenEAS Experlog Application Server
 * Web application development and dynamic template scripting engine
 * Copyright (c) 2004 ExperLog SARL - http://www.experlog.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License,
 * or (at your option) any later version. This program is distributed in
 * the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details. You should have
 * received a copy of the GNU General Public License along with this program;
 * if not, write to the Free Software Foundation, Inc.,
 * 675 Mass Ave, Cambridge, MA 02139, USA.
 */

package org.experlog.actions;

import java.util.StringTokenizer;

import org.experlog.base.ESAction;
import org.experlog.util.Client;
import org.experlog.base.ESServletRequest;
import org.experlog.gencode.DynHtml;

/**
 * @author gibello
 *
 */
public class Validate implements ESAction {
  
  public boolean serverSide() { return false; }

  public boolean processRequest(Client session, ESServletRequest req,
  DynHtml page, Object info) throws Exception {
    
    if(info == null) return true;
    
    String what = info.toString();
    
    if(what.toUpperCase().startsWith("EMAIL")) { // Validate email syntax (may be local)
      what = what.substring(6).trim(); // 6 -> after "email "
      String regex = "^[_A-Za-z0-9-]+(\\.[_A-Za-z0-9-]+)*@[_A-Za-z0-9-]+(\\.[_A-Za-z0-9-]+)*";
      return page.expandString(what).matches(regex);
      
    } else if(what.toUpperCase().startsWith("EXTERNALEMAIL")) { // Validate email syntax (external only)
      what = what.substring(14).trim(); // 14 -> after "externalemail "
      String regex = "^[_A-Za-z0-9-]+(\\.[_A-Za-z0-9-]+)*@[_A-Za-z0-9-]+(\\.[_A-Za-z0-9-]+)+";
      return page.expandString(what).matches(regex);
      
    } else if(what.toUpperCase().startsWith("MATCHES")) { // Match regular expression
      what = what.substring(8).trim(); // 8 -> after "matches "
      StringTokenizer st = new StringTokenizer(what);
      if(! st.hasMoreTokens()) return false;
      String val = st.nextToken();
      return page.expandString(val).matches(what.substring(val.length()).trim());
    }
    
    return false; // Invalid check requested
  }

}
