/*
 * OpenEAS Experlog Application Server
 * Web application development and dynamic template scripting engine
 * Copyright (c) 2004 ExperLog SARL - http://www.experlog.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License,
 * or (at your option) any later version. This program is distributed in
 * the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details. You should have
 * received a copy of the GNU General Public License along with this program;
 * if not, write to the Free Software Foundation, Inc.,
 * 675 Mass Ave, Cambridge, MA 02139, USA.
 */

package org.experlog.db;

import org.experlog.util.AppConfiguration;

public class DatasourceProperty {

    String name;
    String driver;
    String url;
    String user;
    String password;
    String sqlEncodeSubst = null;
    String sqlEncodeSeparator = null;
    String resultSet = null;
    int minConn;
    int maxConn;
    int txIsolation_ = AppConfiguration.INT_DEFAULT;
    long lifeTime;
    long sleepTime;

    public DatasourceProperty(String name) {
        this.name = name;
    }

    public void setDriver(String driver) {
        this.driver = driver;
    }

    public void setUrl(String url) {
        this.url = url;
    }

    public void setUser(String user) {
        this.user = user;
    }

    public void setPassword(String password) {
        this.password = password;
    }

    public void setMinConn(int minConn) {
        this.minConn = minConn;
    }

    public void setMaxConn(int maxConn) {
        this.maxConn = maxConn;
    }

    public void setSqlEncodeSubst(String sqlencode) {
        this.sqlEncodeSubst = sqlencode;
    }

    public void setSqlEncodeSeparator(String sqlencode) {
        this.sqlEncodeSeparator = sqlencode;
    }

    public void setResultSet(String result) {
        this.resultSet = result;
    }

    public void setTxIsolation(int txIsolation) {
	txIsolation_ = txIsolation;
    }

    public void setLifeTime(long lifeTime) {
	this.lifeTime = lifeTime;
    }

    public void setSleepTime(long sleepTime) {
	this.sleepTime = sleepTime;
    }

    public String getName() {
        return name;
    }

    public String getDriver() {
        return driver;
    }

    public String getUrl() {
        return url;
    }

    public String getUser() {
        return user;
    }

    public String getPassword() {
        return password;
    }

    public int getMinConn() {
        return minConn;
    }

    public int getMaxConn() {
        return maxConn;
    }

    public String getSqlEncodeSubst() {
        return sqlEncodeSubst;
    }

    public String getSqlEncodeSeparator() {
        return sqlEncodeSeparator;
    }

    public String getResultSet() {
        return resultSet;
    }

    public int getTxIsolation() { return txIsolation_; }

    public long getLifeTime() {
        return lifeTime;
    }

    public long getSleepTime() {
        return sleepTime;
    }    
}