/*
 * OpenEAS Experlog Application Server
 * Web application development and dynamic template scripting engine
 * Copyright (c) 2004 ExperLog SARL - http://www.experlog.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License,
 * or (at your option) any later version. This program is distributed in
 * the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details. You should have
 * received a copy of the GNU General Public License along with this program;
 * if not, write to the Free Software Foundation, Inc.,
 * 675 Mass Ave, Cambridge, MA 02139, USA.
 */


package org.experlog.gencode;

import java.sql.SQLException;
import javax.servlet.http.HttpServletRequest;

import org.experlog.openeas.api.DataObject;

public class ESHttpHeadersAccess implements DataObject {

  HttpServletRequest req_;

  public ESHttpHeadersAccess(HttpServletRequest req) {
    req_ = req;
  }

  public String get(String name) throws SQLException {

    String h = req_.getHeader(name);
    if(h != null) return h;

    String nm = name.toLowerCase();
    if(nm.equals("request-method")) {
      return req_.getMethod();
    } else if(nm.equals("request-uri")) {
      return req_.getRequestURI();
    } else if(nm.equals("request-protocol")) {
      return req_.getProtocol();
    } else if(nm.equals("servlet-path")) {
      return req_.getServletPath();
    } else if(nm.equals("path-info")) {
      return req_.getPathInfo();
    } else if(nm.equals("path-translated")) {
      return req_.getPathTranslated();
    } else if(nm.equals("query-string")) {
      return req_.getQueryString();
    } else if(nm.equals("content-length")) {
      return Integer.toString(req_.getContentLength());
    } else if(nm.equals("content-type")) {
      return req_.getContentType();
    } else if(nm.equals("server-name")) {
      return req_.getServerName();
    } else if(nm.equals("server-port")) {
      return Integer.toString(req_.getServerPort());
    } else if(nm.equals("remote-user")) {
      return req_.getRemoteUser();
    } else if(nm.equals("remote-address")) {
      return req_.getRemoteAddr();
    } else if(nm.equals("remote-host")) {
      return req_.getRemoteHost();
    } else if(nm.equals("authorization-scheme")) {
      return req_.getAuthType();
    }

    return req_.getHeader(name);
  }

};

